// adm.h -- The -*- C++ -*- alphabetic data management interface.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#ifndef _ADM_H_
#define _ADM_H_

#include <string> // <string> has to be included before STL headers (g++ Bug)

/* Configuration Pararameters */

#include "admlconf.h"

/* BASE TYPES */

/* alphabet */
#include "alphabet.h"

/* astring */
#include "astring.h"

/* atoken */
#include "atoken.h"

/* admalgo */
#include "admalgo.h"

/* single keyword matching */
#include "skm.h"

/* single keyword matching functions */
#include "mfunsskm.h"

/* single keyword text analysis device */
#include "skmtadev.h"

/* single keyword matching algorithms */
#include "bfskm.h"     // Brute Force
#include "bmhskm.h"    // Boyer-Moore-Horspol
#include "bmskm.h"     // Boyer-Moore
#include "kmpskm.h"    // Knuth-Morris-Pratt
#include "krskm.h"     // Karp-Rabin
#include "soskm.h"     // Shift-Or
#include "sqsskm.h"    // Sunday-QuickSearch

#endif
