// bfskm.cc -- The -*- C++ -*- Brute Force methods.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#include "bfskm.h"

/**

  BF_SKM

**/

// MATCHER
#define BFSKM_CC

#define  MATCHER      match             // Match Function
#include "bfskm.cpp"
#undef   MATCHER

#define  BFSKM_RUN
#define  MATCHER      run_matcher       // Run Matcher
#include "bfskm.cpp"
#undef   MATCHER
#undef   BFSKM_RUN            

#undef BFSKM_CC            


// DISPLAY ANALYSIS
void bf_skm::algorithm_step(breakpoint WHERE, int count) {

  adev_mpatt mp(pat);

  switch (WHERE) {

  case INIT_PREPROCESSOR:
    ad->message("PREPROCESSING ...");
    break;

  case PREPROCESSOR_STEP:
    break;

  case INIT_MATCHER:
    ad->message("SEARCHING ...");
    ad->matched_text(txt, ti, mp);
    break;

  case MATCHER_STEP:
    if(ti < txt_end - pat_size)
      ad->matched_text(txt, ti, mp);
    break;

  case PARTIAL_MATCH:
    ad->message("-- PARTIAL MATCH --");
    break;

  case PARTIAL_MATCH_STEP:
    mp.update_pos(pmpi - pat_beg);
    mp.matched_symbols(0, pmpi - pat_beg);
    ad->matched_text(txt, ti, mp);
    break;

  case FULL_MATCH: 
    mp.matched_symbols(0, pat_size);
    ad->matched_text(txt, ti, mp);
    ad->message("-- FULL MATCH --");
    break;

  case MATCH_RECOVERY:
    break;
  };
};

// STATIC OBJECTS
bf_skm bfskm;


