// bfskm.cpp -- The -*- C++ -*- Brute Force skm matcher.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#ifdef BFSKM_CC

// brute force matcher
astring::size_type bf_skm::MATCHER() {

  // LOCAL OPTIMIZATIONS

  // USE p0 INSTEAD OF *pat_beg 
  register skm_patt::value_type p0 = *pat_beg;  

  // USE ti_last INSTEAD OF txt_end - ti ON while LOOP
  register astring::iterator   ti_last = txt_end - pat_size;

#ifndef BFSKM_RUN
  // Redefine the text iterator declaring it in register
  register astring::iterator   ti = this->ti;
#endif

#ifdef BFSKM_RUN
  report_step(INIT_MATCHER); // Step 0, get first text positions

  if (stop) return txt_size;
#endif

  // while the text can give us a match
  //  while (txt_end - ti >= pat_size) { 
  while (ti < ti_last) { 
    // Do partial match if current text symbol == first pattern symbol
    if (*ti==p0) {

      pmpi = pat_beg;
      pmti = ti;

#ifdef BFSKM_RUN
      report_step(PARTIAL_MATCH); // current text symbol == current patt symbol
      if (stop) return txt_size;
#endif

      // Use do-while instead of while to allow patterns of size one.
      do {

	pmpi++; pmti++;

	// If pattern matched apply match function
	if (pmpi == pat_end) {

	  // Internal variables
	  astring::size_type midx; // match index 

	  midx = ti - txt_beg;

#ifdef BFSKM_RUN
	  report_step(FULL_MATCH);
	  if (stop) return txt_size;
#endif
    	  if (report_match(midx)) {
	    return (midx);              // ... return the match
	  } else {
#ifdef BFSKM_RUN
	    report_step(MATCH_RECOVERY);
	    if (stop) return txt_size;
#endif
	    break;                      // continue searching
	  }
	}

#ifdef BFSKM_RUN
	report_step(PARTIAL_MATCH_STEP); // Advance pattern & text
	if (stop) return txt_size;
#endif

      } while (*pmpi==*pmti);

    } // end if

    ti++;

#ifdef BFSKM_RUN
    report_step(MATCHER_STEP); // advance text 
    if (stop) return txt_size;
#endif

  } // end while

  return (txt_size);
};

#endif
