// bfskm.h -- The -*- C++ -*- brute force skm interface.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#ifndef _BFSKM_H_
#define _BFSKM_H_

#include "skm.h"

// ==============================================================
// BMH SKM (Brute Force Single Keyword Matcher) : Class Interface
// ==============================================================

class bf_skm : public skm_algo {

protected:

  // internal variables
  skm_patt::iterator   pmpi;   // Partial match pattern iterator
  astring::iterator    pmti;   // Partial match text iterator

public:

  // constructor / destructor
  bf_skm() : skm_algo() {};
  bf_skm(const alpha &a) : skm_algo(a) {};

  ~bf_skm() {};

  // long algorithm name
  virtual 
  const char * name() const { return "Brute Force"; };

  // short algorithm name
  virtual 
  const char * id() const { return "bf"; };

  // print preprocesed data 
  virtual 
  ostream & print_pdata(ostream &o) const { return o; };

protected:

  virtual 
  void preprocess() {};             // preprocess the pattern (-)

  virtual 
  void run_preprocessor() {};        // run the preprocessor (-)

  virtual 
  astring::size_type match();       // match the pattern

  virtual
  astring::size_type run_matcher(); // run the matcher

  virtual
  void algorithm_step(breakpoint WHERE, int count);
  // algorithm step function(*)
};

// STATIC OBJECTS
extern bf_skm bfskm;

#endif
