#ifndef _ETIP_H
#define _ETIP_H

#include "admlconf.h"

#if HAVE_CURSES_H

#include <eti.h>

#include <iostream.h> // cerr
#include <curses.h>   // endwin()
#include <stdlib.h>   // exit()

class NCursesException
{
public:
  int errorno;
  const char *message;

  NCursesException (const char* msg, int err)
    : message(msg), errorno (err)
    {};

  NCursesException (const char* msg)
    : message(msg), errorno (E_SYSTEM_ERROR)
    {};

  virtual const char *classname() const {
    return "NCursesWindow";
  }
};

inline void THROW(const NCursesException *e) {
  if (e)
    cerr << e->classname() << " error : " << e->message << endl;
  else
    cerr << "Unknown error (THROW called with NULL NCursesException)" << endl;

  endwin(); // restore screen
  
  exit(1);
}

#define THROWS(s)

#endif
 
#endif
