/*  skmalgo.cc -- The -*- C++ -*- single keyword match algorithms methods.
    Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
    This file is part of the C++ Alphabetic Data Management Library.*/

#include "skmalgo.h"

// ================
// SKM_ALGO Methods
// ================

//
// Access to ...
//

//
// Algorithmic methods
//

// Preprocess pattern
void skm_algo::prep(skm_patt &p) {
  
  set_patt(p);          // Set internal variables

  if (p.size() == 0)
    return;

  if (use_sa || ad) {   // if acounting or displaying ...
    stop = false;       // ... don't stop by default
    run_preprocessor(); // ... and run preprocessor
    if (stop) { 
      pat = NULL;       // invalidate preprocessing, algorithm stopped
      return;
    }
  }
  else                  // else ...
    preprocess();       // ... preprocess pattern
};

// Find preprocessed pattern
astring::size_type skm_algo::find_in (astring &t, astring::size_type to) {
  // Boot test :
  //
  // pattern and text should exist and the text offset has to be
  // less than the text size. If the test fails return the text size
  // (no matches).
  
  if (pat == NULL || pat->size() == 0 || t.size() == 0 || t.size() <= to )
    return t.size();
  
  // Reset ...
  
  // ... text
  set_text(t);
  txt_off = to;
  ti = txt_beg + txt_off;
  
  // ... match function
  if (mf != NULL)
    mf->start(this);
  
  // Algorithm execution
  if (use_sa || ad) {     // if acounting or displaying ...
    stop = false;         // ... don't stop by default
    return run_matcher(); // ... and run the matcher
  } else {                // else ...
    return match();       // ... match the pattern
  }
};
