// skmtypes.h -- The -*- C++ -*- single keyword match types.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#ifndef _SKMTYPES_H_
#define _SKMTYPES_H_

/**

  DESCRIPTION
  
  This header defines the base types used with single keyword search
  algorithms. 
  
**/

#include <iostream.h>
#include "astring.h" 
#include "alphabet.h"

// ========
// Typedefs
// ========

typedef astring                        skm_patt;
typedef alphabet<skm_patt::value_type> skm_alpha;

// =====
// enums
// =====

enum skm_breakpoint {
  INIT_PREPROCESSOR,
  PREPROCESSOR_STEP,
  INIT_MATCHER,
  MATCHER_STEP,
  PARTIAL_MATCH,
  PARTIAL_MATCH_STEP,
  FULL_MATCH,
  MATCH_RECOVERY
}; // places where we set breakpoints

// =============
// extern values
// =============

extern const char *   skm_bpnv[]; // break point names vector
extern const int      skm_bpc;    // break points count

// ====================
// forward declarations
// ====================

class skm_algo;  // needed by skm_mfun

// ===================
// Algorithm Utilities
// ===================

// ----------------------------------------------------------
// BITS (auxiliary class for printing bits) : Class Interface
// ----------------------------------------------------------

class bits {
  unsigned int v;
public:
  bits(unsigned int i) : v(i) {};
  operator string() const;

  friend
  ostream& operator<< (ostream &o, const bits &b);
};

// ---------------------------------------------------------
// BITS (auxiliary class for printing bits) : Inline friends
// ---------------------------------------------------------

inline
ostream & operator<< (ostream &o, const bits &b) {
  o << string(b);
  return o;
}

#endif
