// system.h -- The -*- C++ -*- system dependant declarations.
// Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>
// This file is part of the C++ Alphabetic Data Management Library.

#ifndef _SYS_H_
#define _SYS_H_

// Compiler selectors

// D. J. Delorrie's GCC DOS port
#if defined (__DJGPP__) && !defined(__djgpp__)
# define __djgpp__ __DJGPP__
#endif

// Defined only for Metrowerks, code that doesn't depends on the
// compiler should use __macos__
#if defined(__MWERKS__) && ( defined(__MC68K__) || defined(__POWERPC__) )
# define __mwmacos__ __MWERKS__
# define __macos__ 1
#endif

// Select config.h to use
#if defined(__djgpp__)
# include "adml_dos.h"
#elif defined(__macos__)
# include "adml_mac.h"
#else
# include "admlconf.h"
#endif

/* NLS declarations */
/* Actually, the macros supporting the NLS are not checked, nor detected,
   so it does not work, they are here only as a template for future support */

#if HAVE_LOCALE_H
# include <locale.h>
#endif
#if !HAVE_SETLOCALE
# define setlocale(Category, Locale) /* empty */
#endif

#if ENABLE_NLS
# include <libintl.h>
# define _(Text) gettext (Text)
# define N_(Text) gettext (Text)
#else
# undef bindtextdomain
# define bindtextdomain(Domain, Directory) /* empty */
# undef textdomain
# define textdomain(Domain) /* empty */
# define _(Text) Text
# define N_(Text) Text
#endif

#endif
