/*  output.cc -- -*- C++ -*- Streams Output for the skmtest programs 
    Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>

    This file is part of the C++ Alphabetic Data Management Library. */

#include "skmtest.h"

// ================
// Output Functions
// ================

void show_version () {
  cout << program_name << " (" << PACKAGE << " " << VERSION << ")" << endl;
}

void help_msg(int status) {
  cout << _("Use " << program_name << " --help to see a list of options");
  cout << endl;
  exit(status);
}

void show_algonames() {
  int i;
  cout << "\n";
  cout << _("Simple Keyword Matching Algorithms:\n");
  cout << "\n";
  for (i=0; i < skmv.size(); i++) {
    cout << "  * " << skmv[i]->id() << " (" << skmv[i]->name() << ")\n";
  }
  cout << endl;
  exit(0);
};

void show_breakpoints() {
  int i;
  cout << "\n";
  cout << _("Breakpoints:\n");
  cout << "\n";
  for (i=0; i < skm_bpc; i++) {
    cout << "  " << i << " : " << skm_bpnv[i] << "\n";
  }
  cout << endl;
  exit(0);
};
