/*  skmtest.h -- Main test program for the -*- C++ -*- ADML
    Copyright (C) 1997 Sergio Talens-Oliag <sto@uv.es>

    This file is part of the C++ Alphabetic Data Management Library. */

#ifndef _SKMTEST_H_
#define _SKMTEST_H_

#include "system.h" // System Dependant Macros and Functions
#include "adm.h"

#include <iostream.h>
#include <vector>
#include <deque>

//
// GLOBAL VARIABLES
//

extern
char                *program_name; // Program Name

extern
vector<skm_algo *>  skmv;          // Single keyword search algorithms vector

extern
skm_patt            pat;           // Pattern

extern
deque<skm_patt>     pv;            // Patterns Queue

extern
astring             txt;           // Text

extern
char                *txt_filename; // Text File Name

extern
skm_alpha           al;            // Alphabet

//
// FUNCTION PROTOTYPES
//

// Input Functions
char parse_char       (const char *cb, char **ce);
bool read_patt        (const char *s);
bool read_pattv       (const char *s);
bool read_text        ();

// Output Functions
void help_msg         (int status);
void show_version     ();
void show_algonames   ();
void show_breakpoints ();

#endif
